#!/usr/bin/env python3

# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

import unittest
import amulet


class TestDeploy(unittest.TestCase):
    """
    Trivial deployment test for Apache Bigtop Plugin.

    This charm cannot do anything useful by itself, so integration testing
    is done in the bundle.  However, becaues it's a subordinate, it requires
    a principle to confirm that it deploys.
    """

    def test_deploy(self):
        self.d = amulet.Deployment(series='xenial')
        self.d.load({
            'services': {
                'client': {'charm': 'hadoop-client'},
                'plugin': {'charm': 'hadoop-plugin'},
            },
            'relations': [('client', 'plugin')],
        })
        self.d.setup(timeout=900)
        self.d.sentry.wait(timeout=1800)
        self.unit = self.d.sentry['plugin'][0]


if __name__ == '__main__':
    unittest.main()
